summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorBernd Waibel <waebbl@gmail.com>2020-04-18 12:07:13 +0200
committerJoonas Niilola <juippis@gentoo.org>2020-04-26 16:36:46 +0300
commit7d5314ec4b414305861e1aa8a0ed52c354d4a5bd (patch)
treef6e7a210dce89ec1541a5805087f89caabe0e0f7
parentmedia-gfx/zbar: bump to 0.23.1 (diff)
downloadgentoo-7d5314ec4b414305861e1aa8a0ed52c354d4a5bd.tar.gz
gentoo-7d5314ec4b414305861e1aa8a0ed52c354d4a5bd.tar.bz2
gentoo-7d5314ec4b414305861e1aa8a0ed52c354d4a5bd.zip
media-gfx/yafaray: bump to 3.4.1
Closes: https://bugs.gentoo.org/717568 Package-Manager: Portage-2.3.99, Repoman-2.3.22 Signed-off-by: Bernd Waibel <waebbl@gmail.com> Signed-off-by: Joonas Niilola <juippis@gentoo.org>
-rw-r--r--media-gfx/yafaray/Manifest2
-rw-r--r--media-gfx/yafaray/files/yafaray-3.4.1-0001-Respect-user-pre-defined-CXXFLAGS.patch35
-rw-r--r--media-gfx/yafaray/yafaray-3.4.1.ebuild144
3 files changed, 181 insertions, 0 deletions
diff --git a/media-gfx/yafaray/Manifest b/media-gfx/yafaray/Manifest
index 967398bad99..58ccf86d69e 100644
--- a/media-gfx/yafaray/Manifest
+++ b/media-gfx/yafaray/Manifest
@@ -1,2 +1,4 @@
DIST yafaray-blender-exporter-3.3.0.tar.gz 377928 BLAKE2B 7876c78ca6228282648909e566803b33304be0082fab48819340845e3927877b9734f7bc7e09702bf7cbf6477c68932637eb766dc98b9e8e4ab42ca99d2a3595 SHA512 70a1a806d97f6f3b43cdb5d6caac6104f0f63720d5920f6a623078e05e6977d065d2fabca4da1644deb97f09176b88347f0278e4bc699c783d807d3f530421d0
+DIST yafaray-blender-exporter-3.4.1.tar.gz 381253 BLAKE2B b1483c79b14581729f598b92ca504af4a8a73cff54ff2014e8be646eaa2eea7f10074d1dc8c58251d8a987ac6e5ac10d1bc34b80c229f74e6d580bbaa3a3c461 SHA512 1f7baf7bf5953be8b4e004b1509cc23164df0a05e28d33a2301195ea21ad4d4cd6fdd67a0b1af11c1075bab7018e64b38f564be8b647d8513db46feee7d8bf85
DIST yafaray-core-3.3.0.tar.gz 1135360 BLAKE2B 67f6956a3866bfe0b4167f30a7c2c7f05ee23556e9fff7041ff3937e90011e4c2538b706ae27e02351ae555d0d05531f3eb711257591d85f779683c9c42ac6f7 SHA512 32efb87872485c4a188483ae1172cac2eca2281e7b9ab29f184c047b94f3986d65da199a74c169d0e2fd6af59cf37b7deb69dcfb1cb4763bb1ebca30d46b5b90
+DIST yafaray-core-3.4.1.tar.gz 1136077 BLAKE2B a2ce3945f52315084ee744ff4a6733255018196f0000ca6b1786fbd2ec49ade64cb62e98dfba95dca4dec361f47235d59a8c9bd95ee7d095214fc0afbdcb1ee4 SHA512 a9116273fbc2aaaadbc38a65b1eaaa502070ff06f8a2929e880714a9db57188e65cf319c20a3f96e08146af36a67aea139709a633eb024be65319a64330e6f68
diff --git a/media-gfx/yafaray/files/yafaray-3.4.1-0001-Respect-user-pre-defined-CXXFLAGS.patch b/media-gfx/yafaray/files/yafaray-3.4.1-0001-Respect-user-pre-defined-CXXFLAGS.patch
new file mode 100644
index 00000000000..90b2786c3c5
--- /dev/null
+++ b/media-gfx/yafaray/files/yafaray-3.4.1-0001-Respect-user-pre-defined-CXXFLAGS.patch
@@ -0,0 +1,35 @@
+From 2f77edf05ed02955dc08821f322a529063dbfa28 Mon Sep 17 00:00:00 2001
+From: Bernd Waibel <waebbl@gmail.com>
+Date: Sun, 19 Apr 2020 15:39:45 +0200
+Subject: [PATCH] Respect user pre-defined CXXFLAGS
+
+Signed-off-by: Bernd Waibel <waebbl@gmail.com>
+---
+ CMakeLists.txt | 4 ++--
+ 1 file changed, 2 insertions(+), 2 deletions(-)
+
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index 047456f..6733b7d 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -224,7 +224,7 @@ if(NOT WIN32)
+ endif(NOT YAF_BINDINGS_RUBY_DIR)
+
+ # build flags
+- set(CMAKE_CXX_FLAGS "-Wall" CACHE STRING "Default compiler flags" FORCE)
++ set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall" CACHE STRING "Default compiler flags" FORCE)
+
+ if(USER_RELEASE_OPTIMIZATION_FLAGS)
+ set(YAF_CXX_FLAGS_RELEASE ${USER_RELEASE_OPTIMIZATION_FLAGS})
+@@ -263,7 +263,7 @@ else(NOT WIN32)
+
+ # build flags
+ if(MINGW)
+- set(CMAKE_CXX_FLAGS "-Wall" CACHE STRING "Default compiler flags" FORCE)
++ set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall" CACHE STRING "Default compiler flags" FORCE)
+
+ if(USER_RELEASE_OPTIMIZATION_FLAGS)
+ set(YAF_CXX_FLAGS_RELEASE ${USER_RELEASE_OPTIMIZATION_FLAGS})
+--
+2.26.1
+
diff --git a/media-gfx/yafaray/yafaray-3.4.1.ebuild b/media-gfx/yafaray/yafaray-3.4.1.ebuild
new file mode 100644
index 00000000000..e583d32d4b7
--- /dev/null
+++ b/media-gfx/yafaray/yafaray-3.4.1.ebuild
@@ -0,0 +1,144 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_6 )
+
+# doesn't build with ninja when qt5 and python USE flags are both enabled
+CMAKE_MAKEFILE_GENERATOR="emake"
+
+inherit cmake flag-o-matic python-single-r1
+
+DESCRIPTION="A free open-source montecarlo raytracing engine"
+HOMEPAGE="http://www.yafaray.org"
+SRC_URI="https://github.com/YafaRay/Core/archive/v${PV}.tar.gz -> ${PN}-core-${PV}.tar.gz
+ blender? ( https://github.com/YafaRay/Blender-Exporter/archive/v${PV}.tar.gz -> ${PN}-blender-exporter-${PV}.tar.gz )"
+
+S="${WORKDIR}/Core-${PV}"
+
+LICENSE="blender? ( GPL-2+ ) LGPL-2.1"
+SLOT="0"
+KEYWORDS="~amd64 ~x86"
+IUSE="blender +fastmath +fasttrig jpeg opencv openexr png +python qt5 tiff truetype"
+RESTRICT="test"
+
+REQUIRED_USE="
+ blender? ( python )
+ python? ( ${PYTHON_REQUIRED_USE} )
+"
+
+# Note: according to upstream, the blender plugin doesn't work with blender-2.8 (yet).
+RDEPEND="
+ dev-libs/boost:=[nls]
+ dev-libs/libxml2:2
+ sys-libs/zlib
+ jpeg? ( virtual/jpeg:0 )
+ opencv? ( >=media-libs/opencv-3.1.0:= )
+ openexr? ( >=media-libs/openexr-2.2.0:= )
+ png? ( media-libs/libpng:0= )
+ python? (
+ ${PYTHON_DEPS}
+ blender? ( ~media-gfx/blender-2.79b[${PYTHON_SINGLE_USEDEP}] )
+ )
+ qt5? ( dev-qt/qtwidgets:5 )
+ tiff? ( media-libs/tiff:0 )
+ truetype? ( media-libs/freetype:2 )
+"
+DEPEND="${RDEPEND}"
+BDEPEND="python? ( dev-lang/swig )"
+
+PATCHES=(
+ "${FILESDIR}/${P}-0001-Respect-user-pre-defined-CXXFLAGS.patch"
+)
+
+DOCS=( AUTHORS CHANGELOG CODING INSTALL README )
+
+pkg_setup() {
+ use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+ append-flags -pthread
+ append-ldflags -pthread
+
+ cmake_src_prepare
+
+ if use blender; then
+ # fix PLUGIN_PATH
+ sed -e "s/PLUGIN_PATH = os.path.join(__path__\[0\], 'bin'/PLUGIN_PATH = os.path.join(__path__\[0\], '"$(get_libdir)"'/" \
+ -e "s/@YAFARAY_BLENDER_EXPORTER_VERSION@/v"${PV}"/" \
+ -i "${WORKDIR}"/Blender-Exporter-${PV}/__init__.py || die "patching startup file failed"
+ fi
+}
+
+src_configure() {
+ local mycmakeargs=(
+ # enabling BLENDER_ADDON doesn't build anything, but set's some wierd
+ # installation paths, so keep it off and install the files manually.
+ -DBLENDER_ADDON=OFF
+ -DCMAKE_SKIP_RPATH=ON # NULL DT_RUNPATH security problem
+ -DFAST_MATH=$(usex fastmath)
+ -DFAST_TRIG=$(usex fasttrig)
+ -DWITH_Freetype=$(usex truetype)
+ -DWITH_JPEG=$(usex jpeg)
+ -DWITH_OpenCV=$(usex opencv)
+ -DWITH_OpenEXR=$(usex openexr)
+ -DWITH_PNG=$(usex png)
+ -DWITH_QT=$(usex qt5)
+ -DWITH_TIFF=$(usex tiff)
+ -DWITH_XML_LOADER=ON # internal
+ -DWITH_YAF_PY_BINDINGS=$(usex python)
+ -DWITH_YAF_RUBY_BINDINGS=OFF
+ -DYAF_LIB_DIR=$(get_libdir)
+ )
+
+ if use python; then
+ mycmakeargs+=( -DYAF_PY_VERSION=${EPYTHON#python} )
+ fi
+
+ cmake_src_configure
+}
+
+src_install() {
+ cmake_src_install
+
+ if use python; then
+ python_domodule "${BUILD_DIR}/src/bindings/yafaray_v3_interface.py"
+ mv "${ED}"/usr/$(get_libdir)/_yafaray_v3_interface.so "${ED}"/$(python_get_sitedir)/ || die
+ rm -v "${ED}"/usr/$(get_libdir)/yafaray_v3_interface.py || die
+
+ if use qt5; then
+ python_domodule "${BUILD_DIR}/src/bindings/yafqt.py"
+ mv "${ED}"/usr/$(get_libdir)/_yafqt.so "${ED}"/$(python_get_sitedir)/ || die
+ rm -v "${ED}"/usr/$(get_libdir)/yafqt.py || die
+ fi
+ fi
+
+ rm -rv "${ED}"/usr/share/doc/${PN} || die
+
+ if use blender; then
+ pushd "${WORKDIR}/Blender-Exporter-${PV}" || die
+ # grab blender version number for plugin directory
+ local blender_plugin_dir=$(best_version media-gfx/blender)
+ blender_plugin_dir=${blender_plugin_dir##*/} # remove category
+ blender_plugin_dir=${blender_plugin_dir#*-} # remove package name
+ blender_plugin_dir=${blender_plugin_dir%%-*} # remove revision number if exists
+ insinto /usr/share/blender/${blender_plugin_dir}/scripts/addons/yafaray_v3
+ doins -r .
+ popd || die
+ fi
+}
+
+pkg_postinst() {
+ einfo "To confirm your installation is working as expected, run"
+ einfo "yafaray-xml with /usr/share/yafaray/tests/test01/test01.xml"
+ einfo "as an input file, then compare the result to"
+ einfo "'/usr/share/yafaray/tests/test01/test01 - expected render result.png'"
+ if use blender; then
+ elog
+ elog "To use within Blender, navigate to File -> User Preferences -> Add-ons (tab)"
+ elog "and enable 'Render: YafaRay v3 Exporter'. This will make YafaRay available"
+ elog "in the render engines drop-down."
+ fi
+}